/************************************************************************************/
/*  Program name CAPGLIMP_HIST_RATES.sql                                        	*/
/*  Creater:  NIP Karen (PCCW - UniHub)                                         	*/
/*************   History   *************************                                */
/* 27 JAN, 2006   NIP Karen         First created                                   */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLIMP_HIST_RATES';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_GL_HISTORICAL_RATES;
	
	lv_COAID		NUMBER;
		
BEGIN
	FOR C1 IN Cur_F LOOP
		BEGIN
			lv_COAID	:=	CAPBRIMP_COMMON.GetCOAID(C1.SOB_SHORT_NAME);
			
			INSERT INTO GL_HISTORICAL_RATES
			VALUES
			(
			CAPBRIMP_COMMON.GetSOBID(C1.SOB_SHORT_NAME),
			C1.PERIOD_NAME,
			C1.PERIOD_NUM,
			C1.PERIOD_YEAR,
			CAPBRIMP_COMMON.GetSegment(lv_COAID,C1.CODE_COMBINATION_ID_D),
			C1.TARGET_CURRENCY,
			C1.UPDATE_FLAG,
			C1.USAGE_CODE, 
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_NAME),
			C1.LAST_UPDATE_LOGIN,
			C1.RATE_TYPE,
			C1.TRANSLATED_RATE,
			C1.TRANSLATED_AMOUNT,
			C1.ACCOUNT_TYPE,
			C1.ATTRIBUTE1,
			C1.ATTRIBUTE2,
			C1.ATTRIBUTE3,
			C1.ATTRIBUTE4,
			C1.ATTRIBUTE5,
			C1.CONTEXT
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;
	
	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);
	
	COMMIT;
END;
/